# Questionable
> by PandaSoft

Questionable is a collection of annoyance removers and helpers. It fixes things
that could slow you down while questing and grinding. There are features to
help with partying with friends, multiboxing and running through game content.

It does not need much configuration and is unlikely to conflict with your UI.

It uses no third-party libraries and the code is commented, concise and open
source. You're encouraged to make use of it!

## Options
These features are configured on and off using the `/qbl` menu.

Some features deal with trash. Trash items are poor quality or soulbound items
that you cannot ever equip. Q? can handle selling and dropping trash for you.
It will never drop trash worth more than what you are looting.

You may skip anything marked with `(!)` by holding Ctrl, Alt or Shift. There is
also an option to invert this so these actions only happen while you're holding
these keys!

#### Quests
* Automatically accept and turn in quests & dailies. `(!)`
* Print the NPC lore text from quest windows to chat.
* Automatically select the quest reward with the highest value. `(!)`
* Drop trash as needed when your bags are full to complete a quest. `(!)`

#### Party & Friends
* Share & receive completion of quest objectives with your Party.
* Notify your party when you receive a quest.
* Party members can ask for a quest by `Ctrl`-clicking the quest notice.
* Automatically accept party invites from friends.
* Friends can make you follow them with a simple command.
* Friends can invite themselves to your party with a command.
* Friends can ask you to promote them to party leader.

#### Bags & Banking
* Automatically stack bags, bank and your guild bank.
* Automatically deposit reagents when opening a bank.

#### Looting
* Quickly loot items of a desired quality, faster than Auto-Loot! `(!)`
* Profitably stack and replace trash when looting with full bags.
* Toggle if loot placement starts from the left-most or right-most bag.

#### Merchants
* Automatically sell trash and repair when speaking to merchants. `(!)`
* Optionally you may try using guild funds for repairs.

#### Maps
* World and Mini Map coordinates.

#### Notices
* Automatically confirm Disenchant notices.

## Extras
The following features are also provided by Q? by default:

#### Quests
* Automatically loot money and quest items.
* Quest rewards will have the reward worth the most money highlighted in gold.
* Money, XP, currency and faction rewards are printed when accepting quests.
* Q? prints a clickable quest link that takes you to the its Wowhead page.
* `Ctrl`, `Shift` or `Alt` clicking the Quest Tracker numbers will also print a link.

#### Mail
* A new `Loot Mail` button. It will loot everything from mail except COD items.
* The `To:` field is saved & highlighted when sending mails.
* `Alt`-clicking a bag item after filling out a message will mail that item.

#### Bags
* Setting `Ignore this bag` on a bag will make it invisible to Q?.

#### Merchants
* Merchants have a `Sell & Repair` button. It sells trash.
* A list of items sold with a profit total is printed after `Sell & Repair`.

#### Notices
* Confirmation dialogs when rolling for BoP or Disenchant have been removed.
* The general BoP loot confirmation has been removed.
* The 'type delete' deletion dialog has been replaced with the normal one.
* The warning for selling temporarily tradeable items has been removed.

#### Chat
* You may redirect Q? notices to any chat window named Q?. Just make one!

## Please...
Report any bugs! Patches welcome! Have fun!

If you care to add a translation of Q?, we'd love to hear from you.

> Paozu + (H:Mikomido|A:Midomiko) @Wyrmrest Accord
> https://github.com/pandasoft/questionable/

Read the FAQ for answers to known issues:
> https://github.com/pandasoft/Questionable/blob/master/doc/FAQ.md
