local i18n = QBL.i18n[QBL.locale].lib.Mail

QBL.lib.Mail = {}

-- Used to prevent concurrent runs of the Loot All Mail button.
local is_looting = false

-- Frame used to register timer event for looting.
local w_frame = getglobal("WorldFrame")

-- AutoLootMailItem needs to be delayed when called repeatedly.
local elapsed, mail_count, mail_idx, mail_state = 0, 0, 1, 1
local function scan_mail(self, total)
	if mail_state == 1 then
		local _, _, _, _, money, charge, _, items = GetInboxHeaderInfo(mail_idx)
		if charge == 0 and (money > 0 or (items and items > 0))
		then
			AutoLootMailItem(mail_idx)
			mail_state = 2
		else
			if mail_idx > GetInboxNumItems() then mail_idx = 1 end
		end
	elseif mail_state == 2 then
		if elapsed > 9 then
			elapsed = 0
			mail_count = mail_count + 1
			if mail_count == total then mail_state = 3
			else mail_state = 1 end
		else elapsed = elapsed + 1 end
	elseif mail_state == 3 then
		self:SetScript("OnUpdate", nil)
		elapsed, mail_count, mail_idx, mail_state = 0, 0, 1, 1
		is_looting = false
	end
end

function QBL.lib.Mail.loot_all_mail(self)
	if is_looting then return end
	is_looting = true

	local total = 0
	for i = 1, GetInboxNumItems() do
		local _, _, _, _, money, charge, _, items = GetInboxHeaderInfo(i)
		if charge == 0 and (money > 0 or (items and items > 0))
		then total = total + 1 end
	end
	w_frame:SetScript("OnUpdate", function(self)
		scan_mail(self, total) end)
end

-- Displays 'Loot All Mail' button on mail frames.
local loot_mail_btn = CreateFrame("Button", "QBL_loot_mail_btn",
	InboxFrame, "UIPanelButtonTemplate")
loot_mail_btn:SetText(i18n.LOOT_MAIL_BTN)
loot_mail_btn:SetWidth(65)
loot_mail_btn:SetHeight(22)
loot_mail_btn:SetPoint("TopLeft", 60, -31)
loot_mail_btn:RegisterForClicks("AnyUp")
loot_mail_btn:SetScript("OnClick", QBL.lib.Mail.loot_all_mail)

-- Hook to copy the name of the last sent mail to the 'To:' field.
local _SendMailFrame_Reset = SendMailFrame_Reset
SendMailFrame_Reset = function(...)
	local name = strtrim(SendMailNameEditBox:GetText())
	if name == "" then return _SendMailFrame_Reset() end

	_SendMailFrame_Reset()
	SendMailNameEditBox:SetText(name)
	SendMailNameEditBox:HighlightText()
end

-- Hook used to auto-mail alt-clicked items.
local _ContainerFrameItemButton_OnModifiedClick = ContainerFrameItemButton_OnModifiedClick
ContainerFrameItemButton_OnModifiedClick = function(self, btn, ...)
	if btn == "LeftButton" and IsAltKeyDown()
		and SendMailFrame:IsVisible() and not CursorHasItem()
	then
		local bag, slot = self:GetParent():GetID(), self:GetID()
		local texture, count = GetContainerItemInfo(bag, slot)

		PickupContainerItem(bag, slot)
		ClickSendMailItemButton()

		for i = 1, ATTACHMENTS_MAX_SEND do
			local _, _, tex, ct  = GetSendMailItem(i)
			if SendMailNameEditBox:GetText() ~= ""
				and texture == tex and count == ct
			then SendMailFrame_SendMail() end
		end
	else
		return _ContainerFrameItemButton_OnModifiedClick(self, btn, ...)
	end
end
