QBL.util.Text = {}

-- Returns a colorized gold/silver/copper string from copper input.
-- Accepts positive or negative copper values.
function QBL.util.Text.fmt_money(copper)
	if copper == 0 then return 0 end

	local gold = copper / 10000
	if gold >= 1 then
		gold = math.floor(gold)
		copper = copper - (gold * 10000)
		gold = "|cffECCE3F" .. gold .. "g|r"
	elseif 0 > math.ceil(gold) then
		gold = math.ceil(gold)
		copper = copper + (gold * -10000)
		gold = "|cffFF0000" .. gold .. "g|r"
	else gold = nil end

	local silver = copper / 100
	if silver >= 1 then
		silver = math.floor(silver)
		copper = copper - (silver * 100)
		silver = "|cffACAAAC" .. silver .. "s|r"
	elseif 0 > math.ceil(silver) then
		silver = math.ceil(silver)
		copper = copper + (silver * -100)
		silver = "|cffFF0000" .. silver .. "s|r"
	else silver = nil end

	if copper >= 1 then copper = "|cffBD774E" .. copper .. "c|r"
	elseif 0 > copper then copper = "|cffFF0000" .. copper .. "c|r"
	else copper = nil end

	if gold and silver and copper
	then return gold .. " " .. silver .. " " .. copper
	elseif gold and silver and not copper then return gold .. " " .. silver
	elseif gold and not silver and copper then return gold .. " " .. copper
	elseif gold and not silver and not copper then return gold
	elseif not gold and silver and copper then return silver .. " " .. copper
	elseif not gold and silver and not copper then return silver
	else return copper end
end

-- Returns a colorized notice message of 'type'.
function QBL.util.Text.fmt_notice(txt, type)
	if type == "BAD"
	then return "|cffECC5C0[|r|cffC12267" .. txt .. "|r|cffECC5C0]|r "
	elseif type == "GOOD"
	then return "|cffECC5C0[|r|cff98FF98" .. txt .. "|r|cffECC5C0]|r "
	elseif type == "WARN"
	then return "|cffECC5C0[|r|cffFC6C85" .. txt .. "|r|cffECC5C0]|r "
	else return "|cffECC5C0[|r|cffFFE5B4" .. txt .. "|r|cffECC5C0]|r "
	end
end
